#ifndef HRE_H
#define HRE_H

#define HDFA_RE(DFA)		((DFA)->re)
#define HDFA_TABLE(DFA)		((DFA)->table)
#define HDFA_TABLE_N(DFA, N)	((DFA)->table[(N)])
#define HDFA_INDEX(DFA)		((DFA)->tindex)
/* ڰ Է ѱ type   mask  ⿡ ϰ Ǵµ,
   ̰ ʿ  hre_search () Լ ؼ ˻ ϰ  ,  
   ѱ ڵ尪 ȣ (http://hre.kldp.net Ȩ .)   Ȯ 
   DFA ̺  ұϰ ߸ ڵ带 ã  ߰Ǿ.
   ڰ Է ԽĿ ϼ, ڵ,    ׿ 
   mask  . */
#define HDFA_HTMASK(DFA)	((DFA)->htmask)

/*  v0.9  ϰ ִ  ǥ  , ϼ,
   ڵ带  ִ.  (ϼ   а   Ƿ
   Ȯ ϼ ڵ带 Ѵٴ  Ȯ ̴.)  */
#define HTMASK_JOHAB		0x1
#define HTMASK_EUC_KR		0x2
#define HTMASK_UTF_8		0x4

/* ü DFA ̺ ǥϴ ü.    ⿡ ؾ
   Ѵ.  */
struct hdfa
{
  int ** table;			/* ü DFA ̺  ּ */
  char *re;			/* ڰ Է  ǥ ڿ */
  int tindex;			/* ü DFA ̺ index ȣ */

  /* ڰ Է ѱ type   mask  ⿡ Ѵ.  */
  int htmask;
};

/* ڰ  ǥ  ,   ִ ɼ  
   ִ.  */
struct hre_options
{
  /* ǵ  . */
};

/*  ǥ type.
   ̰ ڰ Է  ǥ  ؼ   DFA
   ̺  ִ.  */
typedef struct hdfa * hre_t;
/*  ǥ ؼ 䱸    ִ ɼǵ.  */
typedef struct hre_options hre_option_t;

extern hre_t hre_compile (char *, struct hre_options);
extern int hre_search (hre_t, const char *);
extern void hre_free (hre_t);

#endif
